/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef _WIN32
#include <sys/time.h>
#else

#include <DxcDefs.hpp>
#endif // _WIN32

#include <DataTypes/DxcData.hpp>

using namespace std;
using namespace Dxc;

DxcData::DxcData()
{
    this->timeStamp_ = currentTime();
}

Timestamp DxcData::currentTime()
{
    struct timeval systemTime;
    gettimeofday(&systemTime, NULL);

    Timestamp ret = systemTime.tv_sec;
    ret *= 1000;
    ret += (systemTime.tv_usec/1000);

    return ret;
}

ostream & operator << (ostream &out, const DxcData *msg)
{
    return msg->put(out);
}
