package org.dxc.evaluator.metrics;

/*
 * CPU Time metric.
 */
public class FalsePositives implements DAMetricCalculator {
    private int totalScenarios = -1;
    private int falsePositives = -1;
    private double fpr = Double.NaN;
    private int minPoints = -1;

    public void addSMCalculator(ScenarioMetricCalculator smc) {
        Detection d = (Detection) smc;
        if (d == null)
            return;

        if (totalScenarios < 0
                && !d.getDetection().equals(Detection.DetectionType.UNDEFINED)) {
            totalScenarios = 1;
            falsePositives = 0;
        } else {
            totalScenarios++;
        }

        if (d.getDetection().equals(Detection.DetectionType.FALSE_POSITIVE)) {
            falsePositives++;
        }
    }

    public void calculate() {
        if (totalScenarios == 0)
            fpr = 0;
        else
            fpr = falsePositives / (double) totalScenarios;
    }

    public double getScore() {
        if (totalScenarios >= minPoints)
            return fpr;
        else
            return Double.NaN;
    }

    public void setMinDataPoints(int min) {
        minPoints = min;
    }

    public void print() {
        System.out.println("False Positives Rate: " + fpr);
    }
}