/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_DA_CONFIG_H
#define DXC_DA_CONFIG_H

#include <map>
#include <vector>
#include <string>

namespace Dxc
{

class DAConfig
{
public:
    DAConfig(std::string configFile);

    std::string getName() const;
    std::string getVersion() const;
    std::string getDirectory() const;
    std::string getBinName() const;
    std::string getJavaClass() const;
    std::string getArgs(const std::string& system) const;
    std::string getPlatform() const;

    std::vector<std::string> getSupportedSystems() const;

private:
    std::string name_;
    std::string version_;
    std::string directory_;
    std::string binName_;
    std::string javaClass_;
    std::string platform_;

    std::map<std::string, std::string> systemToArgs_;
};

}

#endif
