/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_SCENARIOTRACKER_HPP
#define DXC_SCENARIOTRACKER_HPP

#ifdef _WIN32
#include <Pthreads-w32/pthread.h>
#else
#include <pthread.h>
#endif

namespace Dxc
{

class ScenarioTracker
{
public:
    static const int ST_WAIT_TIMEOUT = -2;
    static const int ST_ERROR = -1;
    static const int ST_INIT = 0;
    static const int ST_AWAITING_DA = 1;
    static const int ST_STARTED = 2;
    static const int ST_ENDED = 3;

    ScenarioTracker();
    int getStatus();
    void updateStatus(int newStatus);
    int waitForUpdate(long timeoutMillis);
    int waitForUpdate(); // no timeout

private:
    int status_;
    pthread_cond_t statUpdated_;
    pthread_mutex_t condMutex_;
    pthread_mutex_t statMutex_;
};

}

#endif
